% -*- slang -*-

%  This file provides a mode for viewing/editing unified diffs.
%
%  Written by Abraham vd Merwe <abz@blio.net>
%  Basic syntax highligting, nothing else.
%  Last updated: 20 September 2001
%  
%  hacked to work with jed 0.99.14 by Johann Botha <joe@blio.net>
%  * added regex for standard diff output
%  20 September 2001

$1 = "diff";

% Now create and initialize a syntax table.
create_syntax_table ($1);

!if (keymap_p ($1)) make_keymap ($1);

set_syntax_flags ($1,0x01|0x04);

set_color ("number","brown","black");
set_color ("operator","brightred","black");
set_color ("...","white","black");
set_color ("delimiter","green","black");
set_color ("keyword","gray","black");
set_color ("error","cyan","black");
set_color ("preprocess","brown","black");

#ifdef HAS_DFA_SYNTAX
%%% DFA_CACHE_BEGIN %%%
static define setup_dfa_callback (name)
{
   variable color_diff = "number";
   variable color_delete_file = "operator";
   variable color_add_file = "...";
   variable color_position = "delimiter";
   variable color_delete_line = "keyword";
   variable color_add_line = "error";
   
   dfa_enable_highlight_cache ("diff.dfa",name);
   
   dfa_define_highlight_rule ("^diff .*",color_diff,name);
   dfa_define_highlight_rule ("^--- .*",color_delete_file,name);
   dfa_define_highlight_rule ("^\\+\\+\\+ .*",color_add_file,name);
   dfa_define_highlight_rule ("^@@.*@@",color_position,name);
   dfa_define_highlight_rule ("^[0-9].*",color_position,name);
   dfa_define_highlight_rule ("^-.*",color_delete_line,name);
   dfa_define_highlight_rule ("^\\+.*",color_add_line,name);
   dfa_define_highlight_rule ("^> .*",color_add_line,name);
   dfa_define_highlight_rule ("^< .*",color_delete_line,name);
   
   dfa_build_highlight_table (name);
}

dfa_set_init_callback (&setup_dfa_callback, "diff");
%%% DFA_CACHE_END %%%   
#endif

define diff_mode ()
{
   variable kmap = $1;
   set_mode (kmap,4);
   use_keymap (kmap);
   use_syntax_table (kmap);
}

